/* 2006-10-23(by 555)
 * http://hp.vector.co.jp/authors/VA028002/winfreetype.c (higambana(FI))
 * ێʂ
 */
/* 2006-10-27(by 555)
 * http://hp.vector.co.jp/authors/VA028002/freetype.html (higambana(FI))
 * QlɂĂ蒼
 */
/* 2006-10-29(by 555)
 * 693(ƌĂԂƂɂ)͓̐IȊɂďoオEnEn\[X
 * LTCg̕ύX_ɂ݂݂CB(x[Xgdi0164)
 */
/* (by 555)
 * ɐEnEnɂĂgdi0168
 * C^bNƃ{[hǉB
 */
#include "override.h"
#include <windows.h>
//#include <windowsx.h>
#include <tchar.h>

#include <math.h>

#include <ft2build.h>
#include <freetype/freetype.h>	/* FT_FREETYPE_H */
#include <freetype/ftcache.h>	/* FT_CACHE_H */
#include <freetype/tttags.h>	// FT_TRUETYPE_TAGS_H
#include <freetype/tttables.h>	// FT_TRUETYPE_TABLES_H
#include <freetype/ftoutln.h>	// FT_OUTLINE_H


#define FT_FixedToInt(x)	(FT_RoundFix(x) >> 16)
#define FT_PosToInt(x)		(((x) + (1 << 5)) >> 6)
#define RESOLUTION_X 72
#define RESOLUTION_Y 72

FT_Library     freetype_library;
FTC_Manager    cache_man;
FTC_CMapCache  cmap_cache;
FTC_ImageCache image_cache;

// http://kikyou.info/diary/?200510#i10 Qlɂ
#include <mmsystem.h>	//mmioFOURCC
#define TVP_TT_TABLE_ttcf	mmioFOURCC('t', 't', 'c', 'f')
#define TVP_TT_TABLE_name	mmioFOURCC('n', 'a', 'm', 'e')

class CSystemFontData
{
private:
	HDC		m_hdc;
	HFONT	m_hFont, m_hOldFont;
	BYTE	*m_fontdata;
	size_t	m_size;
	int		m_index;

	bool Init(LPCTSTR name);

public:
	CSystemFontData()
		: m_hdc(NULL)
		, m_hFont(NULL)
		, m_hOldFont(NULL)
		, m_fontdata(NULL)
		, m_size(0)
		, m_index(0)
	{
	}
	~CSystemFontData()
	{
		free(m_fontdata);
		if (m_hOldFont) {
			SelectFont(m_hdc, m_hOldFont);
		}
		if (m_hFont) {
			DeleteFont(m_hFont);
		}
		if (m_hdc) {
			DeleteDC(m_hdc);
		}
	}

	BYTE* GetFontData() const
	{
		return m_fontdata;
	}

	static CSystemFontData* CreateInstance(LPCTSTR name);
	BYTE* Lock(size_t *size, int *index);
};


// Windowsɓo^ĂtHg̃oCif[^𖼏̂擾
CSystemFontData* CSystemFontData::CreateInstance(LPCTSTR name)
{
	CSystemFontData* pData = new CSystemFontData;
	if (!pData) {
		return NULL;
	}
	if (!pData->Init(name)) {
		delete pData;
		return NULL;
	}
	return pData;
}

bool CSystemFontData::Init(LPCTSTR name)
{
	m_hdc = CreateCompatibleDC(NULL);
	if(m_hdc == NULL) {
		return false;
	}
	// OȊOK
	m_hFont = CreateFont(
		12, 0, 0, 0, FW_NORMAL,
		FALSE, FALSE, FALSE,
		DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_DONTCARE,
		name);
	if(m_hFont == NULL) {
		return NULL;
	}
	m_hOldFont = SelectFont(m_hdc, m_hFont);
	// tHgf[^ꂻ`FbN
	DWORD result = ::GetFontData(m_hdc, TVP_TT_TABLE_name, 0, NULL, 0);
	if(result == GDI_ERROR){
		return false;
	}
	return true;
}

BYTE* CSystemFontData::Lock(size_t *size, int *index)
{
	unsigned char *name_content    = NULL; // Windows 擾 name ^O̓e
	unsigned char *name_content_ft = NULL; // FreeType 擾 name ^O̓e
	DWORD result;

	DWORD fontsize;
	BOOL IsTTC = FALSE;
	unsigned char buf[4];
	int name_content_size;

	FT_Face face = NULL;

	int i;

	if(index == NULL){
		return NULL;
	}
	if(m_fontdata != NULL){
		*size = m_size;
		*index = m_index;
		return m_fontdata;
	}
	// tHg̎擾
	result = ::GetFontData(m_hdc, TVP_TT_TABLE_name, 0, NULL, 0);
	if(result == GDI_ERROR){
		// G[; GetFontData ł͈Ȃ
		return NULL;
	}
	name_content_size = result;
	name_content = (unsigned char *)malloc(name_content_size);
	name_content_ft = (unsigned char *)malloc(name_content_size);
	::GetFontData(m_hdc, TVP_TT_TABLE_name, 0, name_content, name_content_size);

	// tHgTCY擾
	result = ::GetFontData(m_hdc, TVP_TT_TABLE_ttcf, 0, &buf, 1);
	if(result == 1){
		// TTC t@CƎv
		result = ::GetFontData(m_hdc, TVP_TT_TABLE_ttcf, 0, NULL, 0);
		IsTTC = TRUE;
	}
	else{
		result = ::GetFontData(m_hdc, 0, 0, NULL, 0);
		m_index = 0;
	}
	if(result == GDI_ERROR){
		// G[; GetFontData ł͈Ȃ
		free(name_content);
		free(name_content_ft);
		return NULL;
	}
	fontsize = result;
	m_size = fontsize;
	m_fontdata = (unsigned char *)malloc(fontsize);
	if(m_fontdata == NULL){
		free(name_content);
		free(name_content_ft);
		return NULL;
	}
	if(IsTTC){
		::GetFontData(m_hdc, TVP_TT_TABLE_ttcf, 0, m_fontdata, fontsize);
	}
	else{
		::GetFontData(m_hdc, 0, 0, m_fontdata, fontsize);
	}
	if(!IsTTC){
		*size = m_size;
		*index = m_index;
		free(name_content);
		free(name_content_ft);
		return m_fontdata;
	}

	for(i=0 ;;) {
		FT_ULong length;
		FT_Error err;
		if(FT_New_Memory_Face(
			freetype_library,
			m_fontdata,
			m_size,
			i,
			&face)){
			free(name_content);
			free(name_content_ft);
			return NULL;
		}
		// FreeType Aname ^ÕTCY擾
		length = 0;
		err = FT_Load_Sfnt_Table(face, TTAG_name, 0, NULL, &length);
		if(err){
			FT_Done_Face(face);
			free(name_content);
			free(name_content_ft);
			return NULL;
		}
		// FreeType 瓾 name ^O̒ Windows 瓾Ɣr
		if(length == (DWORD)name_content_size){
			// FreeType  name ^O擾
			err = FT_Load_Sfnt_Table(face, TTAG_name, 0, name_content_ft, &length);
			if(err){
				FT_Done_Face(face);
				free(name_content);
				free(name_content_ft);
				return NULL;
			}
			// FreeType ǂݍ name ^O̓eƁAWindows ǂݍ
			// name ^O̓erB
			// vĂ΂ index ̃tHggB
			if(!memcmp(name_content, name_content_ft, name_content_size)){
				FT_Done_Face(face);
				m_index = i;
				break;
			}
		}
		FT_Done_Face(face);
		i++;
	}

	*size = m_size;
	*index = m_index;
	free(name_content);
	free(name_content_ft);
	return m_fontdata;
}

FORCEINLINE BYTE DoAlphaBlend(BYTE fg, BYTE bg, int alpha)
{
	alpha = Bound(alpha, 0, 255);
	switch (alpha) {
	case 0:
		return bg;
	case 255:
		return fg;
	default:
		{
			WORD temp = ((WORD)(bg)*(WORD)(255 - alpha) +
					(WORD)(fg)*(WORD)((WORD)(alpha)) + (WORD)128);
			return (BYTE)((temp + (temp >> 8)) >> 8);
		}
	}
}

// LCD(t)p̃At@uh(TusNZ_O)
static FORCEINLINE
COLORREF AlphaBlendColorLCD(
		COLORREF baseColor,
		COLORREF newColor,
		int alphaR, int alphaG, int alphaB,
		const int* tableR, const int* tableG, const int* tableB)
{
	const BYTE rs = GetRValue(baseColor);
	const BYTE gs = GetGValue(baseColor);
	const BYTE bs = GetBValue(baseColor);
	BYTE rd = GetRValue(newColor);
	BYTE gd = GetGValue(newColor);
	BYTE bd = GetBValue(newColor);
	// At@l␳
	alphaR = tableR[alphaR];
	alphaG = tableG[alphaG];
	alphaB = tableB[alphaB];
//	rd = (((rd - rs) * alphaR) / 255) + rs;
//	gd = (((gd - gs) * alphaG) / 255) + gs;
//	bd = (((bd - bs) * alphaB) / 255) + bs;
	rd = DoAlphaBlend(rd, rs, alphaR);
	gd = DoAlphaBlend(gd, gs, alphaG);
	bd = DoAlphaBlend(bd, bs, alphaB);
	return RGB(rd, gd, bd);
}

// At@uh(256K)
static FORCEINLINE
COLORREF AlphaBlendColor(
		COLORREF baseColor,
		COLORREF newColor,
		int alpha, const int* table)
{
	const BYTE rs = GetRValue(baseColor);
	const BYTE gs = GetGValue(baseColor);
	const BYTE bs = GetBValue(baseColor);
	BYTE rd = GetRValue(newColor);
	BYTE gd = GetGValue(newColor);
	BYTE bd = GetBValue(newColor);
	// At@l␳
	alpha = table[alpha];
//	rd = (rs * (255 - alpha) + rd * alpha) / 255;
//	gd = (gs * (255 - alpha) + gd * alpha) / 255;
//	bd = (bs * (255 - alpha) + bd * alpha) / 255;

//	rd = (((rd - rs) * alpha) / 255) + rs;
//	gd = (((gd - gs) * alpha) / 255) + gs;
//	bd = (((bd - bs) * alpha) / 255) + bs;
	rd = DoAlphaBlend(rd, rs, alpha);
	gd = DoAlphaBlend(gd, gs, alpha);
	bd = DoAlphaBlend(bd, bs, alpha);
	return RGB(rd, gd, bd);
}

// 2K
static void FreeTypeDrawBitmapPixelModeMono(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const COLORREF color,
		COLORREF backColor,
		const BOOL transParent)
{
	int i, j;
	int dx, dy;	// display
	int width, height;
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_MONO){
		return;
	}

	width = bitmap->width;
	height = bitmap->rows;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow
		for(i = 0, dx = x; i < width; ++i, ++dx){
			if((p[i / 8] & (1 << (7 - (i % 8)))) != 0){
				cache.SetPixelV(dx, dy, color);
			}else if(!transParent){
				cache.SetPixelV(dx, dy, backColor);
			}
		}
	}
}

// LCD(t)p`(TusNZ_O)
// RGB(̂͂)
static void FreeTypeDrawBitmapPixelModeLCD(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const COLORREF color,
		COLORREF backColor,
		const BOOL transParent)
{
	int i, j;
	int dx, dy;	// display
	COLORREF c;
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_LCD){
		return;
	}

	const int AAMode = g_pSettings->AntiAliasMode();
	const int* tableR = g_pSettings->GetTuneTableR();
	const int* tableG = g_pSettings->GetTuneTableG();
	const int* tableB = g_pSettings->GetTuneTableB();

	// LCD3TusNZ
	const int width = bitmap->width;
	const int height = bitmap->rows;
	const int width_3 = width - 3;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow

		int alphaR, alphaG, alphaB;
		i = 0;
		dx = x;
		if(transParent){
			backColor = cache.GetPixel(dx, dy);
		}
		if(AAMode == 2){
			//RGB
			alphaR = (p[i + 0] + p[i + 1]) / 2;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
		}else{
			// BGR
			alphaR = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i + 0] + p[i + 1]) / 2;
		}
		c = AlphaBlendColorLCD(
			backColor, color,
			alphaR, alphaG, alphaB,
			tableR, tableG, tableB
		);
		cache.SetPixelV(dx, dy, c);

		for(i = 3, dx = x + 1; i < width_3; i += 3, ++dx){
			if(transParent){
				backColor = cache.GetPixel(dx, dy);
			}

			if(AAMode == 2){
				// RGB̏ɃTusNZfBXvCp
				alphaR = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
				alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
				alphaB = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
			}else{
				// BGR
				alphaR = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
				alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
				alphaB = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
			}
			c = AlphaBlendColorLCD(
				backColor, color,
				alphaR, alphaG, alphaB,
				tableR, tableG, tableB
			);
			cache.SetPixelV(dx, dy, c);
		}

		if (i >= width)
			continue;
		if(transParent){
			backColor = cache.GetPixel(dx, dy);
		}

		if(AAMode == 2){
			// RGB̏ɃTusNZfBXvCp
			alphaR = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i + 1] + p[i + 2]) / 2;
		}else{
			// BGR
			alphaR = (p[i + 1] + p[i + 2]) / 2;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
		}
		c = AlphaBlendColorLCD(
			backColor, color,
			alphaR, alphaG, alphaB,
			tableR, tableG, tableB
		);
		cache.SetPixelV(dx, dy, c);
	}
}

// Otrbg}bṽ_O
static void FreeTypeDrawBitmap(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const COLORREF color,
		COLORREF backColor,
		const BOOL transParent)
{
	int i, j;
	int dx, dy;	// display
	int width, height;
	COLORREF c;
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_GRAY){
		// ̊֐̂FT_PIXEL_MODE_GRAYɂ̂ݑΉɈϏ
		switch(bitmap->pixel_mode){
		case FT_PIXEL_MODE_MONO:
			FreeTypeDrawBitmapPixelModeMono(
				cache, bitmap, x, y, color,
				backColor, transParent);
			break;
		case FT_PIXEL_MODE_LCD:
			FreeTypeDrawBitmapPixelModeLCD(
				cache, bitmap, x, y, color,
				backColor, transParent);
			break;
		default:
			return;		// Ή
		}
		return;
	}

	const int* table = g_pSettings->GetTuneTable();
	width = bitmap->width;
	height = bitmap->rows;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow
		for(i = 0, dx = x; i < width; ++i, ++dx){
			if(transParent){
				backColor = cache.GetPixel(dx, dy);
			}
			c = AlphaBlendColor(
				backColor, color,
				p[i], table
			);
			cache.SetPixelV(dx, dy, c);
		}
	}
}

// FreeTypepTextOut APIǂ
BOOL FreeTypeTextOut(
	const HDC hdc,     // foCXReLXg̃nh
	CBitmapCache& cache,
	const LOGFONTW& lf,
	const int nXStart, // Jnʒui_j x W
	const int nYStart, // Jnʒui_j y W
	LPCWSTR lpString,  // 
	int cbString,      // 
	const int* lpDx    // `ʒu
	)
{
	CCriticalSectionLock __lock;

	BOOL ret = FALSE;
	COLORREF color;
	COLORREF backColor;
	BOOL transParent;
	int p;
	int x, y;

	FTC_FaceID face_id;
	FT_Face freetype_face;
	FT_Int cmap_index;
	FT_Size font_size;
	FTC_ScalerRec scaler;
	FTC_ImageTypeRec font_type;
	FT_Render_Mode render_mode = FT_RENDER_MODE_NORMAL;

	FT_Bool useKerning;
	FT_UInt previous;

	// Unicodeœn悤ɂ(FT_Select_CharmapŕύX\)
	LPCWSTR wstr = lpString;
	if(cbString <= 0 || lpString == NULL)
		goto Exit1;

	face_id = (FTC_FaceID)g_pSettings->FT_GetFontIdByName(lf.lfFaceName);
	if(FTC_Manager_LookupFace(cache_man, face_id, &freetype_face))
		goto Exit2;
	cmap_index = FT_Get_Charmap_Index(freetype_face->charmap);

	scaler.face_id = face_id;
	scaler.width = lf.lfWidth;
	if(lf.lfHeight > 0){
		// Z
		scaler.height =
			lf.lfHeight *
			freetype_face->units_per_EM /
			(freetype_face->ascender - freetype_face->descender);
	}
	else{
		// 
		scaler.height = -lf.lfHeight;
	}
	scaler.pixel = 1;
	scaler.x_res = 0;
	scaler.y_res = 0;
	if(FTC_Manager_LookupSize(cache_man, &scaler, &font_size))
		goto Exit2;

/*	FT_Size_RequestRec size_request;
	size_request.width = lf.lfWidth;
	size_request.horiResolution = 0;
	size_request.vertResolution = 0;
	if(lf.lfHeight > 0){
		// Z
		size_request.type = FT_SIZE_REQUEST_TYPE_CELL;
		size_request.height = lf.lfHeight * 64;
	}
	else{
		// 
		size_request.type = FT_SIZE_REQUEST_TYPE_NOMINAL;
		size_request.height = (-lf.lfHeight) * 64;
	}
	if(FT_Request_Size(freetype_face, &size_request))
		goto Exit2;*/

	// font_typeݒ
	font_type.face_id = face_id;
	font_type.width   = freetype_face->size->metrics.x_ppem;
	font_type.height  = freetype_face->size->metrics.y_ppem;

	/* rbg}bv܂ŃLbVꍇFT_LOAD_RENDER | FT_LOAD_TARGET_*
	 * ƂBrTARGETύXꍇ̓LbVזB
	 * FT_LOAD_DEFAULTɂFTC_ImageCache_Lookup
	 * FT_Glyph_To_BitmapقsƎvB
	 */
	if(lf.lfWeight > FW_NORMAL || lf.lfItalic){
		// {[hAC^bN͌Ń_O
		// x͗򉻂邾낤ǎdȂB
		font_type.flags = FT_LOAD_NO_BITMAP;
	}
	else{
		font_type.flags = FT_LOAD_RENDER | FT_LOAD_NO_BITMAP;
	}
	// qeBO
	switch (g_pSettings->HintingMode()) {
	case 0:
		// ignore.
		break;
	case 1:
		font_type.flags |= FT_LOAD_NO_HINTING;
		break;
	case 2:
		font_type.flags |= FT_LOAD_FORCE_AUTOHINT;
		break;
	}
	// A`GCAX
	switch (g_pSettings->AntiAliasMode()) {
	case 0:
		font_type.flags |= FT_LOAD_TARGET_NORMAL;
		render_mode = FT_RENDER_MODE_NORMAL;
		break;
	case 1:
		font_type.flags |= FT_LOAD_TARGET_LIGHT;
		render_mode = FT_RENDER_MODE_LIGHT;
		break;
	case 2:
		font_type.flags |= FT_LOAD_TARGET_LCD;
		render_mode = FT_RENDER_MODE_LCD;
		break;
	}

	// `FEwiF擾
	color = GetTextColor(hdc);
	backColor = GetBkColor(hdc);
	transParent = GetBkMode(hdc) == TRANSPARENT;
	// ͈̑̑ؖ

	p = 0;
	x = 0;
	/* x[XC̈ʒu
	 * size->metrics.height6rbǧŒ菬ł̃tHg̍
	 * ascender̓x[XC̒
	 * units_per_EMascenderdescenderAheight̒P
	 */
	TRACE(_T("%ls, asc:%d, des:%d, height: %d, met: %d, uPe: %d\n"), lf.lfFaceName,
			freetype_face->ascender, freetype_face->descender, freetype_face->height,
			FT_PosToInt(freetype_face->size->metrics.height), freetype_face->units_per_EM);
//	y = (freetype_face->height + freetype_face->descender) *
//		(freetype_face->size->metrics.height >> 6) / freetype_face->units_per_EM;
//	y = (freetype_face->ascender) *
//		((freetype_face->size->metrics.height + (1 << 5)) >> 6) / freetype_face->units_per_EM;
	y = MulDiv(freetype_face->height + freetype_face->descender,
				freetype_face->size->metrics.y_ppem, freetype_face->units_per_EM);

	useKerning = g_pSettings->EnableKerning() && FT_HAS_KERNING(freetype_face);
	previous = 0;

	x += nXStart;
	y += nYStart;

	while(p < cbString){
		FT_Glyph glyph;
		FT_BitmapGlyph glyph_bitmap;

		FT_Glyph copy_glyph;
		FT_Bool use_copy = 0;

		// BMPO͍̕lĂȂB
		// BMPOɂĂ̓TQ[gyAl邩UTF-32ɂ΂낤
		FT_UInt glyph_index = FTC_CMapCache_Lookup(
			cmap_cache,
			face_id,
			cmap_index,
			wstr[p]);
		if(glyph_index == 0)
			goto Exit2;

		// J[jO
		if(useKerning){
			if(previous != 0 && glyph_index){
				FT_Vector delta;
				FT_Get_Kerning(freetype_face,
					previous, glyph_index,
					ft_kerning_default, &delta);
				if (!lpDx) {
					x += FT_PosToInt(delta.x);
				}
			}
			previous = glyph_index;
		}

		if(FTC_ImageCache_Lookup(
			image_cache,
			&font_type,
			glyph_index,
			&glyph,
			NULL))
		{
			goto Exit2;
		}
		/* font_type.flagsFT_LOAD_RENDERIȂ
		 * OtC[W擾Ă̂Ńrbg}bvɕϊB
		 */
		if(glyph->format == FT_GLYPH_FORMAT_BITMAP){
			glyph_bitmap = (FT_BitmapGlyph)glyph;
		}
		else{
			if(FT_Glyph_Copy(glyph, &copy_glyph))
				goto Exit2;
			use_copy = 1;

			// AEgCό`(LTCg)B
			if(lf.lfWeight > FW_NORMAL){
				// 
				int strength;
				strength = (lf.lfWeight - FW_NORMAL) / 8;	// 
				if(FT_Outline_Embolden(
					&((FT_OutlineGlyph)copy_glyph)->outline,
					strength))
				{
					goto Exit2;		// ϊs
				}
			}
			if(lf.lfItalic){
				// Α
				FT_Matrix matrix;
				// ϊ(l͓K)
				matrix.xx = 1 << 16;
				matrix.xy = 0x5800;
				matrix.yx = 0;
				matrix.yy = 1 << 16;
				FT_Outline_Transform(
					&((FT_OutlineGlyph)copy_glyph)->outline,
					&matrix);
			}

			/* FT_RENDER_MODE_NORMALŕʂ(256K)A`GCAX
			 * FT_RENDER_MODE_LCDŉtpA`GCAX(TusNZ_O)
			 */
			if(FT_Glyph_To_Bitmap(&copy_glyph, render_mode, 0, 1)){
				FT_Done_Glyph(copy_glyph);
				goto Exit2;
			}
			glyph_bitmap = (FT_BitmapGlyph)copy_glyph;
		}
		FreeTypeDrawBitmap(cache,
			&glyph_bitmap->bitmap,
			x + glyph_bitmap->left,
			y - glyph_bitmap->top,
			color, backColor, transParent);

		if (lpDx) {
			x += *lpDx++;
		} else {
			x += FT_FixedToInt(glyph_bitmap->root.advance.x);
		}

		if(use_copy){
			FT_Done_Glyph(copy_glyph);
		}
		++p;	// Next Charctor
	}

	// ()
	if(lf.lfUnderline){
		//̈ʒu
		int yPos = y + 1;
		const int height = FT_PosToInt(freetype_face->size->metrics.height);
		if (yPos >= height) {
			yPos = height - 1;
		}
		// Kȑ
		const int thickness =
			MulDiv(freetype_face->underline_thickness,
					freetype_face->size->metrics.y_ppem,
					freetype_face->units_per_EM);
		cache.DrawHorizontalLine(nXStart, yPos, x, color, thickness);
	}

	// ()
	if(lf.lfStrikeOut){
		// ̈ʒu(FreeTypeŎ擾łɂȂ̂Win32APIp)
		OUTLINETEXTMETRIC otm = { sizeof(OUTLINETEXTMETRIC) };
		GetOutlineTextMetrics(hdc, otm.otmSize, &otm);
		const int yPos = y - otm.otmsStrikeoutPosition;
		// Kȑ
		const int thickness =
			MulDiv(freetype_face->underline_thickness,
					freetype_face->size->metrics.y_ppem,
					freetype_face->units_per_EM);
		cache.DrawHorizontalLine(nXStart, yPos, x, color, thickness);
	}

	ret = TRUE;
Exit2:
Exit1:
	return ret;
}

BOOL FreeTypeGetTextExtentPoint(
	const HDC hdc,
	LPCWSTR lpString,
	int cbString,
	LPSIZE lpSize
	)
{
	CCriticalSectionLock __lock;

	//قƂǏ̂Rs
	BOOL ret = FALSE;
	int p;
	int x, y;

	FTC_FaceID face_id;
	FT_Face freetype_face;
	FT_Int cmap_index;
	FT_Size font_size;
	FTC_ScalerRec scaler;
	FTC_ImageTypeRec font_type;
	FT_Render_Mode render_mode = FT_RENDER_MODE_NORMAL;

	FT_Bool useKerning;
	FT_UInt previous;
	LOGFONTW lf = { 0 };

	// Unicodeœn悤ɂ(FT_Select_CharmapŕύX\)
	LPCWSTR wstr = lpString;
	if(cbString <= 0 || lpString == NULL || !lpSize)
		goto Exit1;

	extern HFONT GetCurrentFont(HDC hdc);
	if (!GetObject(GetCurrentFont(hdc), sizeof(LOGFONTW), &lf))
		goto Exit1;

	face_id = (FTC_FaceID)g_pSettings->FT_GetFontIdByName(lf.lfFaceName);
	if(FTC_Manager_LookupFace(cache_man, face_id, &freetype_face))
		goto Exit2;
	cmap_index = FT_Get_Charmap_Index(freetype_face->charmap);
	scaler.face_id = face_id;
	scaler.width = lf.lfWidth;
	if(lf.lfHeight > 0){
		// Z
		scaler.height =
			lf.lfHeight *
			freetype_face->units_per_EM /
			(freetype_face->ascender - freetype_face->descender);
	}
	else{
		// 
		scaler.height = -lf.lfHeight;
	}
	scaler.pixel = 1;
	scaler.x_res = 0;
	scaler.y_res = 0;
	if(FTC_Manager_LookupSize(cache_man, &scaler, &font_size))
		goto Exit2;

	// font_typeݒ
	font_type.face_id = face_id;
	font_type.width   = freetype_face->size->metrics.x_ppem;
	font_type.height  = freetype_face->size->metrics.y_ppem;

	/* rbg}bv܂ŃLbVꍇFT_LOAD_RENDER | FT_LOAD_TARGET_*
	 * ƂBrTARGETύXꍇ̓LbVזB
	 * FT_LOAD_DEFAULTɂFTC_ImageCache_Lookup
	 * FT_Glyph_To_BitmapقsƎvB
	 */
	if(lf.lfWeight > FW_NORMAL || lf.lfItalic){
		// {[hAC^bN͌Ń_O
		// x͗򉻂邾낤ǎdȂB
		font_type.flags = FT_LOAD_NO_BITMAP;
	}
	else{
		font_type.flags = FT_LOAD_RENDER | FT_LOAD_NO_BITMAP;
	}
	// qeBO
	switch (g_pSettings->HintingMode()) {
	case 0:
		// ignore.
		break;
	case 1:
		font_type.flags |= FT_LOAD_NO_HINTING;
		break;
	case 2:
		font_type.flags |= FT_LOAD_FORCE_AUTOHINT;
		break;
	}
	// A`GCAX
	switch (g_pSettings->AntiAliasMode()) {
	case 0:
		font_type.flags |= FT_LOAD_TARGET_NORMAL;
		render_mode = FT_RENDER_MODE_NORMAL;
		break;
	case 1:
		font_type.flags |= FT_LOAD_TARGET_LIGHT;
		render_mode = FT_RENDER_MODE_LIGHT;
		break;
	case 2:
		font_type.flags |= FT_LOAD_TARGET_LCD;
		render_mode = FT_RENDER_MODE_LCD;
		break;
	}

	p = 0;
	x = 0;
	/* x[XC̈ʒu
	 * size->metrics.height6rbǧŒ菬ł̃tHg̍
	 * ascender̓x[XC̒
	 * units_per_EMascenderdescenderAheight̒P
	 */
//	TRACE(_T("%ls, asc:%d, des:%d, height: %d, met: %d, uPe: %d\n"), lf.lfFaceName,
//			freetype_face->ascender, freetype_face->descender, freetype_face->height,
//			freetype_face->size->metrics.height >> 6, freetype_face->units_per_EM);
	y = FT_PosToInt(freetype_face->size->metrics.height);

	useKerning = g_pSettings->EnableKerning() && FT_HAS_KERNING(freetype_face);
	previous = 0;

	while(p < cbString){
		FT_Glyph glyph;
		FT_BitmapGlyph glyph_bitmap;

		FT_Glyph copy_glyph;
		FT_Bool use_copy = 0;

		// BMPO͍̕lĂȂB
		// BMPOɂĂ̓TQ[gyAl邩UTF-32ɂ΂낤
		FT_UInt glyph_index = FTC_CMapCache_Lookup(
			cmap_cache,
			face_id,
			cmap_index,
			wstr[p]);

		// J[jO
		if(useKerning){
			if(previous != 0 && glyph_index){
				FT_Vector delta;
				FT_Get_Kerning(freetype_face,
					previous, glyph_index,
					ft_kerning_default, &delta);
					x += FT_PosToInt(delta.x);
			}
			previous = glyph_index;
		}

		if(FTC_ImageCache_Lookup(
			image_cache,
			&font_type,
			glyph_index,
			&glyph,
			NULL))
		{
			goto Exit2;
		}
		/* font_type.flagsFT_LOAD_RENDERIȂ
		 * OtC[W擾Ă̂Ńrbg}bvɕϊB
		 */
		if(glyph->format == FT_GLYPH_FORMAT_BITMAP){
			glyph_bitmap = (FT_BitmapGlyph)glyph;
		}
		else{
			if(FT_Glyph_Copy(glyph, &copy_glyph))
				goto Exit2;
			use_copy = 1;

			// AEgCό`(LTCg)B
			if(lf.lfWeight > FW_NORMAL){
				// 
				int strength;
				strength = (lf.lfWeight - FW_NORMAL) / 8;	// 
				if(FT_Outline_Embolden(
					&((FT_OutlineGlyph)copy_glyph)->outline,
					strength))
				{
					goto Exit2;		// ϊs
				}
			}
			if(lf.lfItalic){
				// Α
				FT_Matrix matrix;
				// ϊ(l͓K)
				matrix.xx = 1 << 16;
				matrix.xy = 0x5800;
				matrix.yx = 0;
				matrix.yy = 1 << 16;
				FT_Outline_Transform(
					&((FT_OutlineGlyph)copy_glyph)->outline,
					&matrix);
			}

			/* FT_RENDER_MODE_NORMALŕʂ(256K)A`GCAX
			 * FT_RENDER_MODE_LCDŉtpA`GCAX(TusNZ_O)
			 */
			if(FT_Glyph_To_Bitmap(&copy_glyph, render_mode, 0, 1)){
				FT_Done_Glyph(copy_glyph);
				goto Exit2;
			}
			glyph_bitmap = (FT_BitmapGlyph)copy_glyph;
		}
		x += FT_FixedToInt(glyph_bitmap->root.advance.x);

		if(use_copy){
			FT_Done_Glyph(copy_glyph);
		}
		++p;	// Next Charctor
	}

	lpSize->cx = x;
	lpSize->cy = y;
	ret = TRUE;
Exit2:
Exit1:
	if (!ret && lpSize) {
		lpSize->cx = lpSize->cy = 0;
	}
	return ret;

	//܂ĂȂ̎c[
//	return ORIG_GetTextExtentPoint32W(hdc, lpString, cbString, lpSize);
}

BOOL FreeTypeGetTextMetrics(const HDC hdc, LPTEXTMETRICW lptm)
{
	CCriticalSectionLock __lock;

	//قƂǏ̂Rs
	BOOL ret = FALSE;

	FTC_FaceID face_id;
	FT_Face freetype_face;
	FT_Int cmap_index;
	FT_Size font_size;
	FTC_ScalerRec scaler;
	FTC_ImageTypeRec font_type;

	LOGFONTW lf = { 0 };

	extern HFONT GetCurrentFont(HDC hdc);
	if (!GetObject(GetCurrentFont(hdc), sizeof(LOGFONTW), &lf))
		goto Exit1;

	face_id = (FTC_FaceID)g_pSettings->FT_GetFontIdByName(lf.lfFaceName);
	if(FTC_Manager_LookupFace(cache_man, face_id, &freetype_face))
		goto Exit2;
	cmap_index = FT_Get_Charmap_Index(freetype_face->charmap);
	scaler.face_id = face_id;
	scaler.width = lf.lfWidth;
	if(lf.lfHeight > 0){
		// Z
		scaler.height =
			lf.lfHeight *
			freetype_face->units_per_EM /
			(freetype_face->ascender - freetype_face->descender);
	}
	else{
		// 
		scaler.height = -lf.lfHeight;
	}
	scaler.pixel = 1;
	scaler.x_res = 0;
	scaler.y_res = 0;
	if(FTC_Manager_LookupSize(cache_man, &scaler, &font_size))
		goto Exit2;

	// font_typeݒ
	font_type.face_id = face_id;
	font_type.width   = freetype_face->size->metrics.x_ppem;
	font_type.height  = freetype_face->size->metrics.y_ppem;

	/* rbg}bv܂ŃLbVꍇFT_LOAD_RENDER | FT_LOAD_TARGET_*
	 * ƂBrTARGETύXꍇ̓LbVזB
	 * FT_LOAD_DEFAULTɂFTC_ImageCache_Lookup
	 * FT_Glyph_To_BitmapقsƎvB
	 */
	font_type.flags   = FT_LOAD_RENDER | FT_LOAD_NO_BITMAP;
	// qeBO
	switch (g_pSettings->HintingMode()) {
	case 0:
		// ignore.
		break;
	case 1:
		font_type.flags |= FT_LOAD_NO_HINTING;
		break;
	case 2:
		font_type.flags |= FT_LOAD_FORCE_AUTOHINT;
		break;
	}
	// A`GCAX
	switch (g_pSettings->AntiAliasMode()) {
	case 0:
		font_type.flags |= FT_LOAD_TARGET_NORMAL;
		break;
	case 1:
		font_type.flags |= FT_LOAD_TARGET_LIGHT;
		break;
	case 2:
		font_type.flags |= FT_LOAD_TARGET_LCD;
		break;
	}

	TRACE(_T("%ls, asc:%d, des:%d, height: %d, met: %d, uPe: %d\n"), lf.lfFaceName,
			freetype_face->ascender, freetype_face->descender, freetype_face->height,
			FT_PosToInt(freetype_face->size->metrics.height), freetype_face->units_per_EM);
	lptm->tmHeight  = FT_PosToInt(freetype_face->size->metrics.height);
	lptm->tmAscent  = MulDiv(freetype_face->ascender, lptm->tmHeight, freetype_face->units_per_EM);
	lptm->tmDescent = -MulDiv(freetype_face->descender, lptm->tmHeight, freetype_face->units_per_EM);

	ret = TRUE;
Exit2:
Exit1:
	return ret;
}

unsigned long StreamIoFunc(
		FT_Stream stream,
		unsigned long offset,
		unsigned char* buffer,
		unsigned long count)
{
	if(count != 0){
		CSystemFontData* font = reinterpret_cast<CSystemFontData*>(stream->descriptor.pointer);
		unsigned char* p;
		unsigned long copycount;
		if(font == NULL || font->GetFontData() == NULL)
			return 0;
		p = font->GetFontData();
		if(offset > stream->size)
			return 0;	// error
		copycount = offset + count > stream->size ?
				stream->size - offset :
				count;
		p += offset;
		if(buffer != NULL)
			memcpy(buffer, p, copycount);
		return copycount;
	}
	return 0;
}

void StreamCloseFunc(FT_Stream stream){
	CSystemFontData* font = reinterpret_cast<CSystemFontData*>(stream->descriptor.pointer);
	delete font;
	free(stream);
}

FT_Error face_requester(
		FTC_FaceID face_id,
		FT_Library library,
		FT_Pointer request_data,
		FT_Face* aface)
{
	FT_Error ret;
	FT_Face face;

	LPCTSTR fontname = g_pSettings->FT_GetFontNameById((int)face_id);
	CSystemFontData *systemFont;
	size_t size;
	int index;
	unsigned char *data;
	FT_Stream stream;
	FT_Open_Args args;

	// ̂w肵ătHg擾
	systemFont = CSystemFontData::CreateInstance(fontname);

	if(systemFont == NULL){
		ret = FT_Err_Cannot_Open_Resource;
		goto Exit;
	}
	data = systemFont->Lock(&size, &index);
	if(data == NULL){
		ret = FT_Err_Cannot_Open_Resource;
		delete systemFont;
		goto Exit;
	}
	stream = (FT_Stream)malloc(sizeof(FT_StreamRec));
	if(stream == NULL){
		ret = FT_Err_Out_Of_Memory;
		delete systemFont;
		goto Exit;
	}
	memset(stream, 0, sizeof(FT_StreamRec));
	stream->base = 0;
	stream->size = size;
	stream->pos = 0;
	stream->descriptor.pointer = systemFont;
	stream->pathname.pointer = NULL;
	stream->read = StreamIoFunc;
	stream->close = StreamCloseFunc;

	memset(&args, 0, sizeof(args));
	args.flags = FT_OPEN_STREAM;
	args.stream = stream;
	args.driver = 0;
	args.num_params = 0;
	args.params = NULL;

	if((ret = FT_Open_Face(freetype_library, &args, index, &face)) != FT_Err_Ok){
		// sꍇstream͏ɉ
		goto Exit;
	}

	// Charmapݒ肵Ă
	if((ret = FT_Select_Charmap(face, FT_ENCODING_UNICODE)) != FT_Err_Ok){
		FT_Done_Face(face);
		goto Exit;
	}

	*aface = (FT_Face)face;
Exit:
	return ret;
}

BOOL FontLInit(void){
	CCriticalSectionLock __lock;

	if(FT_Init_FreeType(&freetype_library)){
		return FALSE;
	}
	if(FTC_Manager_New(freetype_library, 0, 0, 0,
		face_requester, NULL,
		&cache_man))
	{
		FT_Done_FreeType(freetype_library);
		freetype_library = NULL;
		return FALSE;
	}
	if(FTC_CMapCache_New(cache_man, &cmap_cache)){
		FTC_Manager_Done(cache_man);
		cache_man = NULL;
		FT_Done_FreeType(freetype_library);
		freetype_library = NULL;
		return FALSE;
	}
	if(FTC_ImageCache_New(cache_man, &image_cache)){
		FTC_Manager_Done(cache_man);
		cache_man = NULL;
		FT_Done_FreeType(freetype_library);
		freetype_library = NULL;
		return FALSE;
	}
	return TRUE;
}
void FontLFree(void){
	CCriticalSectionLock __lock;

	if(cache_man != NULL)
		FTC_Manager_Done(cache_man);
	if(freetype_library != NULL)
		FT_Done_FreeType(freetype_library);
}
