#include "common.h"
CRITICAL_SECTION CCriticalSectionLock::m_cs;

#ifndef PathFindExtension
//MSJCabviewTvq
LPTSTR PathFindExtension(LPCTSTR pszPath)
{
	LPCTSTR pszDot;

	for (pszDot = NULL; *pszPath; pszPath = CharNext(pszPath))
	{
		switch (*pszPath) {
		case TEXT('.'):
			pszDot = pszPath;		// remember the last dot
			break;
		case TEXT('\\'):
		case TEXT(' '):				// extensions can't have spaces
			pszDot = NULL;			// forget last dot, it was in a directory
			break;
		}
	}

	// if we found the extension, return ptr to the dot, else
	// ptr to end of the string (NULL extension) (cast->non const)
	return pszDot ? (LPTSTR)pszDot : (LPTSTR)pszPath;
}
#endif
